/*****************************************************
IARAVR V5.4
Chip type               : ATtiny13A
AVR Core Clock frequency: 9,600000 MHz
*****************************************************/
#define   ENABLE_BIT_DEFINITIONS    
#include  <ioavr.h>                 
#include  <intrinsics.h>

unsigned char tmr0,tmr1,tmr2,a=0xff,mst;
char cntfb;


#define s_step 188
__flash unsigned char s_table [s_step/2]=
{0,2,4,6,8,10,12,15,17,19,21,23,25,27,29,31,33,36,38,40,42,
44,46,48,50,52,54,56,58,59,61,63,65,67,69,71,72,74,76,77,79,81,
83,84,86,87,89,90,92,93,95,96,98,99,100,102,103,104,105,107,108,109,110,
111,112,113,114,115,116,117,118,118,119,120,121,121,122,123,123,124,124,125,125,126,
126,126,126,127,127,127,127,127,127,127};

void t0_cfg()        
{
 TCCR0A=1<<COM0A1|1<<COM0A0|1<<COM0B1|1<<WGM00; 
 TCCR0B=1; OCR0A=OCR0B=0xff/2;  //phase correct pwm, top 0xff, no prsc
 TIMSK0|=1<<TOIE0;
}
void ports_cfg()
{
	PORTB=1<<3|1<<1|1<<0;
 	DDRB =1<<1|1<<0;
}

#pragma vector=TIM0_OVF_vect
__interrupt void t0_ovf (void)
{
#define dtv 4
 static unsigned char c=0, tmp_table=0;
 static char d=1,p=1;
 
 tmp_table=((unsigned int)s_table [c]*mst)>>8;
 
 if((d)&&(p))                                          
 {
    OCR0A=0x80+tmp_table;
    if(OCR0A<=0xff-dtv){OCR0B=OCR0A+dtv;}else{OCR0B=OCR0A=0xff;}
    if(c<s_step/2-1){c++;} else {d=0;if(tmr0)tmr0--;}  
 } 
    else if((!d)&&(p))
    {
        OCR0A=0x80+tmp_table;
        if(OCR0A<=0xff-dtv){OCR0B=OCR0A+dtv;}else{OCR0A=OCR0B=0xff;}
        if(c){c--;} else {d=1;p=0;if(tmr1)tmr1--;}
    }
        else if((d)&&(!p)) 
        {
         OCR0B=0x7f-tmp_table;
         if(OCR0B>=dtv){OCR0A=OCR0B-dtv;}else{OCR0A=OCR0B=0;}
         if(c<s_step/2-1){c++;} else {d=0;if(tmr2)tmr2--;}
        }
            else
            {
             OCR0B=0x7f-tmp_table;
             if(OCR0B>=dtv){OCR0A=OCR0B-dtv;}else{OCR0A=OCR0B=0;}
             if(c){c--;}else {d=1;p=1; cntfb=1;mst=a; }
            } 
asm("wdr"); 
}            


void main(void)
{
ports_cfg();
t0_cfg();


asm("sei");

while (1)
      {

         
      }
}

